
//  TESTER.java         CS 120     Fall 2016     Assignement A8
//                                 Instr.  J. Horn
//
//  This code can be used to test most of the methods in the Target
//  interface.   This code needs Target.class, Button.class, and
//  of course your class which implements Target.  Substitute your
//  class name for "JeffTarget" in first three lines of the "Tester"
//  method below, then compile and run.
//  (Make sure that the class files listed above are in the
//  same folder as this file.  If not the .class files, then at least
//  the .java files should be there.   The compiler will compile
//  those into the .class files it needs.)   Read the comments below
//  to see how it all works together.  Note that three objects of
//  the Target class are created.   Click on an object to select it.
//  NOTE:   You can move the targets with the arrow keys.   See the
//          code in "keyPressed" if you want to see how that is done.
//  NOTE:   Not ALL methods in the Target interface are tested here!
//          For example, none of the "physics" methods, such "move",
//          are used here.  If you want to test these, you must add
//          your own methods calls below.


import java.awt.*;
import java.awt.event.*;

public class Tester extends java.applet.Applet implements MouseListener, KeyListener
       {
		 //  State variable declarations

		 private int mx, my;    //   Coordinates of last mouse click.
         private Target target1,target2, target3; // Three Target objects
         private Button moveLeft;
         private Button moveRight;
         private Button damage;


		 public Tester()
		   {
                  target1 = new JeffTarget();    // CHANGE "JeffTarget
                  target2 = new JeffTarget();    // TO YOUR CLASS NAME
                  target3 = new JeffTarget();    // IN ALL THREE LINES.

				  moveLeft = new Button(80, 130, 30, 50, "LEFT");
				  moveRight = new Button(150, 200, 30, 50, "RIGHT");
				  damage = new Button(220, 300, 30, 50, "DAMAGE (-5)");
				  addMouseListener( this );
				  addKeyListener(this);
				  target1.setXY(50,200);   // Move targets to initial
				  target2.setXY(100,200);  // locations.
                  target3.setXY(150,200);
                  target1.setScore(100);      //  Give all targets 100 pts.
				  target2.setScore(100);
                  target3.setScore(100);
		   }

         public void paint(Graphics g)
              {
				  g.setColor(Color.black);

                  target1.paint(g);     //  Paint all three targets.
                  target2.paint(g);
                  target3.paint(g);

                  g.setColor(Color.blue); //   Print targets' scores just below targets.
                  g.drawString(""+target1.getScore(),target1.getX()+10,target1.getY()+55);
                  g.drawString(""+target2.getScore(),target2.getX()+10,target2.getY()+55);
                  g.drawString(""+target3.getScore(),target3.getX()+10,target3.getY()+55);

                  //  Print getEpitaphs of any dead targets, just above them.
                  if(target1.getScore() < 0)
                     g.drawString(target1.getEpitaph(),target1.getX(),target1.getY()-5);
                  if(target2.getScore() < 0)
                     g.drawString(target2.getEpitaph(),target2.getX(),target2.getY()-5);
                  if(target3.getScore() < 0)
                     g.drawString(target3.getEpitaph(),target3.getX(),target3.getY()-5);

                  //    Paint all three buttons
                  moveLeft.paint(g);
                  moveRight.paint(g);
                  damage.paint(g);

                  //  Draw a red circle around any "selectedQ" targets.
                  g.setColor(Color.red);
                  if(target1.selectedQ())
                     g.drawOval(target1.getX() - 5,target1.getY()-5, 50,50);
                  if(target2.selectedQ())
                     g.drawOval(target2.getX() - 5,target2.getY()-5, 50,50);
                  if(target3.selectedQ())
                     g.drawOval(target3.getX() - 5,target3.getY()-5, 50,50);

 			  }

		 public void mouseExited(MouseEvent me) {}
		 public void mouseEntered(MouseEvent me) {}
		 public void mouseClicked( MouseEvent me) {}
		 public void mouseReleased( MouseEvent me) {}
	     public void mousePressed( MouseEvent me)
	        {
				mx = me.getX();
				my = me.getY();

				// TARGET SELECTION: Check all targets.  If mousepress was inside
				//   one of them, then select that target and unselect the others.
				if(inside(target1,mx,my))
				    {  target1.select(); target2.unselect(); target3.unselect(); }
				if(inside(target2,mx,my))
				    {  target1.unselect(); target2.select(); target3.unselect(); }
				if(inside(target3,mx,my))
				    {  target1.unselect(); target2.unselect(); target3.select(); }

				//  BUTTON CLICKS:   If mousepress was inside any button, then
				//                   implement that button's functionality for any
				//                   selectedQ targets.
                if(moveLeft.inside(mx, my))    //  LEFT button.
                    {
						if(target1.selectedQ())    // Move target1 left two pixels.
						    target1.setXY(target1.getX()-2, target1.getY());
						if(target2.selectedQ())    // Move target1 left two pixels.
						    target2.setXY(target2.getX()-2, target2.getY());
						if(target3.selectedQ())    // Move target1 left two pixels.
						    target3.setXY(target3.getX()-2, target3.getY());
				    }
                if(moveRight.inside(mx, my))   //  RIGHT button.
                    {
						if(target1.selectedQ())
						    target1.setXY(target1.getX()+2, target1.getY());
						if(target2.selectedQ())
						    target2.setXY(target2.getX()+2, target2.getY());
						if(target3.selectedQ())
						    target3.setXY(target3.getX()+2, target3.getY());
				    }
                if(damage.inside(mx, my))     // DAMAGE button.  Reduce score of
                    {                         //   any selectedQ targets by 5.
						if(target1.selectedQ())
						    target1.addToScore(-5);
						if(target2.selectedQ())
						    target2.addToScore(-5);
						if(target3.selectedQ())
						    target3.addToScore(-5);
				    }

                repaint();    //  Update graphics window.
		    }

          //  INSIDE(t,x,y).  Because I forgot to add the all-important "inside" method
          //  to the Target interface, I cannot expect your Target class to have such a
          //  method.  Fortunately, the interface is rich enough in methods that there
          //  ARE some we can use to make our own "inside" method.
          //  This method returns TRUE if and only if (x,y) is inside the 40 by 40 pixel
          //  bounding box of the Target t, specifically the box with upper left corner
          //  at location (t.getX(), t.getY()).
          private boolean inside(Target t, int x, int y)
            {
				return (t.getX() < x && x < t.getX() +40 && t.getY() < y && y < t.getY()+40) ;
			}


          public void keyListener(KeyEvent e) {}
          public void keyReleased(KeyEvent e) {}
          public void keyTyped(KeyEvent e) {}
		  public void keyPressed(KeyEvent e) // respond to key strokes.
		   {
			  int changeAMT = 2; //  Amount to move, any direction, in pixels
			  int changeInX = 0; //  Amount to move in x-direction
			  int changeInY =0;  //  Amount to move in y-direction
			  if (e.getKeyCode() == KeyEvent.VK_UP)  //  If UP-ARROW pressed
			     {  changeInX = 0; changeInY = - changeAMT;  }  // move up.
			  else if (e.getKeyCode() == KeyEvent.VK_DOWN)   //  DOWN-ARROW...
			          {  changeInX = 0; changeInY = changeAMT;  }
			       else if (e.getKeyCode() == KeyEvent.VK_LEFT)//  LEFT-ARROW...
			               {  changeInX = - changeAMT; changeInY = 0;  }
			            else if (e.getKeyCode() == KeyEvent.VK_RIGHT) // RIGHT-ARROW
			                     { changeInX = changeAMT; changeInY = 0;  }
			  // Move only those Targets that are SELECTED.
			  if(target1.selectedQ())
				   target1.setXY(target1.getX()+changeInX, target1.getY()+changeInY);
			  if(target2.selectedQ())
				target2.setXY(target2.getX()+changeInX, target2.getY()+changeInY);
			  if(target3.selectedQ())
				target3.setXY(target3.getX()+changeInX, target3.getY()+changeInY);
              repaint();
		   }

	    }


